<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblPuntoVentaRepository;

final class TblPuntoVentaService
{
    private TblPuntoVentaRepository $TblPuntoVentaRepository;

    public function __construct(TblPuntoVentaRepository $TblPuntoVentaRepository)
    {
        $this->TblPuntoVentaRepository = $TblPuntoVentaRepository;
    }

    public function checkAndGet(int $TblPuntoVentaId): object
    {
        return $this->TblPuntoVentaRepository->checkAndGet($TblPuntoVentaId);
    }

    public function getAll(): array
    {
        return $this->TblPuntoVentaRepository->getAll();
    }

    public function getOne(int $TblPuntoVentaId): object
    {
        return $this->checkAndGet($TblPuntoVentaId);
    }

    public function create(array $input): object
    {
        $TblPuntoVenta = json_decode((string) json_encode($input), false);

        return $this->TblPuntoVentaRepository->create($TblPuntoVenta);
    }

    public function update(array $input, int $TblPuntoVentaId): object
    {
        $TblPuntoVenta = $this->checkAndGet($TblPuntoVentaId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblPuntoVentaRepository->update($TblPuntoVenta, $data);
    }

    public function delete(int $TblPuntoVentaId): void
    {
        $this->checkAndGet($TblPuntoVentaId);
        $this->TblPuntoVentaRepository->delete($TblPuntoVentaId);
    }
}
